Attribute VB_Name = "Module2"
'Load JPG or Bitmap
' IJL.DLL is a copyright  Intel, which is a registered trade mark of the Intel Corporation.

Option Explicit

Private Type RGBQUAD
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
    rgbReserved As Byte
End Type

Private Type BITMAPINFOHEADER '40 bytes
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type

Private Type BITMAP
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type

Private Type BITMAPINFO
    bmiHeader As BITMAPINFOHEADER
    bmiColors As RGBQUAD
End Type

' IJL Declares:
Private Enum IJLERR
  '// The following "error" values indicate an "OK" condition.
  IJL_OK = 0
  IJL_INTERRUPT_OK = 1
  IJL_ROI_OK = 2
End Enum

Private Enum IJLIOTYPE
  IJL_SETUP = -1&
  IJL_JFILE_READPARAMS = 0&
  IJL_JFILE_READWHOLEIMAGE = 2&
End Enum

Private Type JPEG_CORE_PROPERTIES_VB ' Sadly, due to a limitation in VB (UDT variable count)
                                     ' we can't encode the full JPEG_CORE_PROPERTIES structure
  UseJPEGPROPERTIES As Long                      '// default = 0

  '// DIB specific I/O data specifiers.
  DIBBytes As Long ';                  '// default = NULL 4
  DIBWidth As Long ';                  '// default = 0 8
  DIBHeight As Long ';                 '// default = 0 12
  DIBPadBytes As Long ';               '// default = 0 16
  DIBChannels As Long ';               '// default = 3 20
  DIBColor As Long ';                  '// default = IJL_BGR 24
  DIBSubsampling As Long  ';            '// default = IJL_NONE 28

  '// JPEG specific I/O data specifiers.
  JPGFile As Long 'LPTSTR              JPGFile;                32   '// default = NULL
  JPGBytes As Long ';                  '// default = NULL 36
  JPGSizeBytes As Long ';              '// default = 0 40
  JPGWidth As Long ';                  '// default = 0 44
  JPGHeight As Long ';                 '// default = 0 48
  JPGChannels As Long ';               '// default = 3
  JPGColor As Long           ';                  '// default = IJL_YCBCR
  JPGSubsampling As Long  ';            '// default = IJL_411
  JPGThumbWidth As Long ' ;             '// default = 0
  JPGThumbHeight As Long ';            '// default = 0

  '// JPEG conversion properties.
  cconversion_reqd As Long ';          '// default = TRUE
  upsampling_reqd As Long ';           '// default = TRUE
  jquality As Long ';                  '// default = 75.
  jprops(0 To 19999) As Byte
End Type

Private Declare Function ijlInit Lib "ijl11.dll" (jcprops As Any) As Long
Private Declare Function ijlFree Lib "ijl11.dll" (jcprops As Any) As Long
Private Declare Function ijlRead Lib "ijl11.dll" (jcprops As Any, ByVal ioType As Long) As Long

Private Const BI_RGB = 0&
Private Const DIB_RGB_COLORS = 0 '  color table in RGBs
Private Const MAX_PATH = 260

Private Type FILETIME ' 8 Bytes
dwLowDateTime As Long
dwHighDateTime As Long
End Type

Private Type WIN32_FIND_DATA ' 318 Bytes
dwFileAttributes As Long
ftCreationTime As FILETIME
ftLastAccessTime As FILETIME
ftLastWriteTime As FILETIME
nFileSizeHigh As Long
nFileSizeLow As Long
dwReserved_ As Long
dwReserved1 As Long
cFileName As String * MAX_PATH
cAlternate As String * 14
End Type


' Win32 Declares
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (lpvDest As Any, lpvPic As Any, ByVal cbCopy As Long)
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function CreateDIBSection Lib "gdi32" (ByVal hdc As Long, pBitmapInfo As BITMAPINFO, ByVal un As Long, lplpVoid As Long, ByVal handle As Long, ByVal dw As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function LoadImage Lib "user32" Alias "LoadImageA" (ByVal hInst As Long, ByVal lpsz As String, ByVal un1 As Long, ByVal n1 As Long, ByVal n2 As Long, ByVal un2 As Long) As Long
Private Declare Function GetObjectAPI Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Private Declare Function FindFirstFile& Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA)
Private Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long

'Load JPG
Public Function LoadJPG(ByVal sFile As String)

Dim ThisJpg As JPEG_CORE_PROPERTIES_VB
Dim bFile() As Byte
Dim lR As Long
Dim lPtr As Long
Dim lJPGWidth As Long, lJPGHeight As Long
Dim Addr As Long
Dim BytesPerScanLine As Long
Dim binfo As BITMAPINFO

LoadedOK = False

'Is the dll in Windows\System?
If FileFound("C:\Windows\System\ijl11.dll") = False Then
    If FileFound(App.Path & "\ijl11.dll") = True Then
    Dim Response
    Response = MsgBox("To be able to read .jpg files, you need IJL11.dll (written by Intel)" + Chr(13) + "in your c:\Windows\System directory." + Chr(13) + "May I copy the dll to your Windows\System directory?", vbYesNo + vbQuestion, "Real Time Rotation")
        If Response = vbYes Then
        FileCopy App.Path & "\ijl11.dll", "C:\Windows\System\ijl11.dll"
        Else
        MsgBox "Program aborted.", vbCritical, "Real Time Rotation": GoTo ExitNow
        End If
    Else
    MsgBox "To be able to read .jpg files, you need IJL11.dll (written by Intel)" + Chr(13) + "in your c:\Windows\system directory." + Chr(13) + "Sorry, but can't find the dll and unable to continue.", vbCritical, "Real Time Rotation": GoTo ExitNow
    End If
End If

lR = ijlInit(ThisJpg)
If lR = IJL_OK Then
       
    ' Write the filename to the jcprops.JPGFile member:
    bFile = StrConv(sFile, vbFromUnicode)
    ReDim Preserve bFile(0 To UBound(bFile) + 1) As Byte
    bFile(UBound(bFile)) = 0
    lPtr = VarPtr(bFile(0))
    CopyMemory ThisJpg.JPGFile, lPtr, 4
       
    ' Read the JPEG file parameters:
    lR = ijlRead(ThisJpg, IJL_JFILE_READPARAMS)
        If lR <> IJL_OK Then
            ' Throw error
            MsgBox "Failed to read JPG", vbExclamation
            Else
            ' set JPG color
                If ThisJpg.JPGChannels = 1 Then
                ThisJpg.JPGColor = 4& ' IJL_G
                Else
                ThisJpg.JPGColor = 3& ' IJL_YCBCR
                End If
        End If
             
    ' Get the JPGWidth ...
    lJPGWidth = ThisJpg.JPGWidth
    ' .. & JPGHeight member values:
    lJPGHeight = ThisJpg.JPGHeight
    
   'Create DC for the Dib
    PicDC = CreateCompatibleDC(ByVal 0&)
    
    ' Initialize the DIBSection header
    With binfo.bmiHeader
        .biSize = 40
        .biWidth = lJPGWidth
        .biHeight = lJPGHeight
        .biPlanes = 1
        .biBitCount = 24
        .biCompression = BI_RGB
    BytesPerScanLine = ((.biWidth * 3) + 3) And &HFFFFFFFC
        .biSizeImage = BytesPerScanLine * .biHeight
    End With
    PicDib = CreateDIBSection(PicDC, binfo, DIB_RGB_COLORS, Addr, 0, 0)
    PicDst = SelectObject(PicDC, PicDib)
             
    'Store DIBWidth:
    ThisJpg.DIBWidth = lJPGWidth
    'Store DIBHeight:
    ThisJpg.DIBHeight = -lJPGHeight
    'How many bytes extra there are on each DIB scan line to pad to 32 bit boundaries:
    ThisJpg.DIBPadBytes = BytesPerScanLine - lJPGWidth * 3
    'Store Channels:
    ThisJpg.DIBChannels = 3&
    'Store DIBBytes (pointer to uncompressed JPG data):
    ThisJpg.DIBBytes = Addr
    'Now decompress the JPG into the DIBSection:
    lR = ijlRead(ThisJpg, IJL_JFILE_READWHOLEIMAGE)
    'Check Results
        If lR <> IJL_OK Then
        MsgBox "Cannot read Image Data from file.", vbExclamation
        Else
        LoadedOK = True
        End If
Else
MsgBox "Sorry, can't read JPG File. Program aborted.", vbCritical, "Real Time Rotation"
End If

ExitNow:
'Ensure we have freed memory:
ijlFree ThisJpg
CopyMemory ByVal VarPtr(bFile(0)), 0&, 4
Erase bFile
End Function

'Load Bitmap
Public Function LoadBitmap(ByVal sFile As String)

LoadedOK = False
'Load picture. Needs 24 bit bitmaps.
PicDib = LoadImage(ByVal 0&, sFile, 0&, 0&, 0&, &H10 Or &H2000)
If PicDib = 0 Then MsgBox "Sorry, can't find the bitmap. Program aborted", vbCritical, "Real Time Rotation": GoTo ExitNow
On Error GoTo ExitNow
'Get bitmap info
Dim PicBm As BITMAP
GetObjectAPI PicDib, Len(PicBm), PicBm
'Exit if not a supported bitmap
If PicBm.bmBitsPixel <> 24 Then MsgBox "24 bit bitmaps only. Try again.", vbCritical, "Real Time Rotation": GoTo ExitNow
'Create memory device
PicDC = CreateCompatibleDC(ByVal 0&)
'Select the bitmap to this memory device
PicDst = SelectObject(PicDC, PicDib)
LoadedOK = True

ExitNow:

End Function

'Ensure dll is Loaded
Public Function FileFound(strFileName As String) As Boolean
Dim lpFindFileData As WIN32_FIND_DATA
Dim hFindFirst As Long

hFindFirst = FindFirstFile(strFileName, lpFindFileData)

If hFindFirst > 0 Then
    FindClose hFindFirst
    FileFound = True
Else
    FileFound = False
End If

End Function



